from ctypes import * 
import tkinter as tk 
from tkinter import ttk


class IXUD_DEVICE_INFO(Structure):
    _fields_ = [
        ('dwSize', c_ulong),
        ('wVendorID', c_ushort),
        ('wDeviceID', c_ushort),
        ('wSubVendorID', c_ushort),
        ('wSubDeviceID', c_ushort),
        ('dwBAR', c_ulong * 6),
        ('BusNo', c_ubyte),
        ('DevNo', c_ubyte),
        ('IRQ', c_ubyte),
        ('Aux', c_ubyte),
        ('dwBarVirtualAddress', c_ulonglong * 6)
    ]
PIXUD_DEVICE_INFO = POINTER(IXUD_DEVICE_INFO)


class IXUD_CARD_INFO(Structure):
    _fields_ = [
        ('dwSize', c_ulong),
        ('dwModelNo', c_ulong),
        ('CardID', c_ubyte),
        ('wSingleEnded', c_ubyte),
        ('wAIOResolution', c_ushort),
        ('wAIChannels', c_ushort),
        ('wAOChannels', c_ushort),
        ('wDIPorts', c_ushort),
        ('wDOPorts', c_ushort),
        ('wDIOPorts', c_ushort),
        ('wDIOPortWidth', c_ushort),
        ('wCounterChannels', c_ushort),
        ('wMemorySize', c_ushort),
        ('dwReservedl', c_ulong *6)
    ]
PIXUD_CARD_INFO = POINTER(IXUD_CARD_INFO)



_wRtn = c_ushort(0)
_wTotalBoard = c_ushort(0)
sDevInfo = IXUD_DEVICE_INFO()
sCardInfo = IXUD_CARD_INFO()

ptrdev_to_struct = pointer(sDevInfo)
ptrcar_to_struct = pointer(sCardInfo)
ptrdev=[]
ptrcar=[]

string1 = "Modelname"
b_string1 = string1.encode('utf-8')


chan=[]
Board=[]


'''
Window size is related to screen resolution. 
Please adjust the window and its components to appropriate sizes and positions according to the screen resolution.
'''
root = tk.Tk()
root.title('Analog_Output_Voltage_Hex')
root.geometry("430x200")#Window size


dll = cdll.LoadLibrary('UniDAQ.dll')
print("Initialize and Open UniDAQ DLL")

_wRtn = dll.Ixud_DriverInit(byref(_wTotalBoard))

for i in range(0,_wTotalBoard.value):
    _wRtn = dll.Ixud_GetCardInfo(i,ptrdev_to_struct,ptrcar_to_struct,b_string1)
    string1=b_string1.decode('utf-8')
    if string1 !="0":
        Board.append(str(i)+': '+string1)
    else:
        Board.append(str(i)+': Err Device')
    ptrdev.append(ptrdev_to_struct)
    ptrcar.append(ptrcar_to_struct)


def Board_selected(event):
    global chan,ptrcar
    chan=[]
    for i in range(0,(ptrcar[mycombobox.current()].contents.wAOChannels)):
        chan.append('Channel'+str(i))
    chan_box['values'] = chan
    chan_box.current(0)
    cbxConfig.current(3)



def writeAO():
    wRtn = dll.Ixud_ConfigAO(c_ushort(mycombobox.current()), c_ushort(chan_box.current()), c_ushort(cbxConfig.current()))
    
    #Write Analog Output Value (HEX) ->The Range For PISO-DA4U is[0000~3FFF]
    wRtn = dll.Ixud_WriteAOVoltageH(c_ushort(mycombobox.current()), c_ushort(chan_box.current()), hex(int(num_AO.get(),16)))
    #print(c_ushort(wRtn))



def root_destroy():
    wRtn = dll.Ixud_DriverClose()
    root.destroy()



tk.Label(root,text="Board",width=10,height=1).place(x=10,y=18)
comboboxText = tk.StringVar()
mycombobox = ttk.Combobox(root, textvariable=comboboxText, state='readonly')
mycombobox['values'] = Board
mycombobox.place(x=90,y=20)

mycombobox.bind('<<ComboboxSelected>>', Board_selected)


tk.Label(root,text="Channel",width=10,height=1).place(x=10,y=58)
chan_text = tk.StringVar()
chan_box= ttk.Combobox(root, textvariable=chan_text, state='readonly')
chan_box.place(x=90,y=60)


tk.Label(root,text="AO Range",width=10,height=1).place(x=10,y=98)
comboboxText1 = tk.StringVar()
cbxConfig = ttk.Combobox(root, textvariable=comboboxText1, state='readonly')
cbxConfig['values'] = ['0: 0 ~ 5',
'1:+/- 5',
'2:0 ~ 10',
'3:+/- 10',
'4:0 ~ 20',
'5:+/- 20']
cbxConfig.place(x=90,y=100)



num_AO= tk.StringVar()
num_AO.set('')
tk.Label(root,text="Value(Hex)",width=10,height=1).place(x=10,y=140)
entry_out = tk.Entry(root,textvariable=num_AO,justify='right').place(x=90,y=140,height=25,width=165)



Output_btn = tk.Button(root,text="Output",command=writeAO).place(x=300,y=45,height=50,width=100)
Exit_btn = tk.Button(root,text="Exit",command=root_destroy).place(x=300,y=115,height=50,width=100)












root.mainloop()